<!--
.. title: Documentation
.. slug: documentation
.. date: 2020-07-06 17:25:28 UTC
.. tags:
.. category:
.. link:
.. description:
.. type: text
-->

# Man pages

* [mosquitto] - running the Mosquitto broker
* [mosquitto.conf] - the Mosquitto broker configuration file
* [mosquitto_passwd] - command line utility for generating Mosquitto password files
* [mosquitto_pub] - command line utility for publishing messages to a broker
* [mosquitto_rr] - command line utility for simple request/response with a broker
* [mosquitto_sub] - command line utility for subscribing to topics on a broker
* [mosquitto-tls] - brief cheat sheet for creating x509 certificates
* [mqtt] - description of MQTT features

# libmosquitto API

* [libmosquitto API documentation]

# Other

* [Authentication methods] - details on the different authentication options available.
* [Dynamic Security plugin] - details of using the Dynamic Security authentication and access control plugin.
* [Using the snap package] - specific instructions on installing and configuring the Mosquitto snap package.
* [Migrating from 1.x to 2.0] - details of changes needed to migrate to version 2.0.

# Third party

These are some Mosquitto documentation hosted by third parties.

* [Steve's internet guide] - a broad range of documentation and examples
  covering Mosquitto and the Paho Python client, amongst others.
* [docs.cedalo.com] - includes documentation for both Mosquitto and Eclipse
  Streamsheets

[mosquitto]:/man/mosquitto-8.html
[mosquitto.conf]:/man/mosquitto-conf-5.html
[mosquitto_passwd]:/man/mosquitto_passwd-1.html
[mosquitto_pub]:/man/mosquitto_pub-1.html
[mosquitto_rr]:/man/mosquitto_rr-1.html
[mosquitto_sub]:/man/mosquitto_sub-1.html
[mosquitto-tls]:/man/mosquitto-tls-7.html
[mqtt]:/man/mqtt-7.html

[libmosquitto API documentation]:/api/

[Authentication methods]:/documentation/authentication-methods/
[Using the snap package]:/documentation/using-the-snap/
[Dynamic Security plugin]:/documentation/dynamic-security/
[Migrating from 1.x to 2.0]:/documentation/migrating-to-2-0/

[Steve's internet guide]: http://www.steves-internet-guide.com/
[docs.cedalo.com]: https://docs.cedalo.com/
